#define cupsextraversion rc1
%define cupsextraversion %nil
%define major	2
%define libname	%mklibname %{name} %{major}

%define with_poll_ppd_base 0


%define bootstrap 0
%{?_without_bootstrap: %global bootstrap 0}
%{?_with_bootstrap: %global bootstrap 1}

%global lspp 0

# {_exec_prefix}/lib/cups is correct, even on x86_64.
# It is not used for shared objects but for executables.
# It's more of a libexec-style ({_libexecdir}) usage,
# but we use lib for compatibility with 3rd party drivers (at upstream request).
%global cups_serverbin %{_exec_prefix}/lib/cups

Summary:	Common Unix Printing System - Server package
Name:		cups
Version:	1.7.0
%define subrel	1
Release:	%mkrel 7
License:	GPLv2 and LGPLv2
Group:		System/Printing
%define real_version %{version}%{cupsextraversion}

Source: http://www.cups.org/software/%{version}/cups-%{version}-source.tar.bz2

# Small C program to get list of all installed PPD files
Source1: poll_ppd_base.c
# socket unit for cups-lpd service
Source3: cups-lpd.socket
# cups-lpd service unit configuration
Source4: cups-lpd@.service
# Logrotate configuration
Source6: cups.logrotate
# Backend for NCP protocol
Source7: ncp.backend
# Backend filter for nprint (Novell client) from Mark Horn
# (mark@hornclan.com)
Source11: http://www.hornclan.com/~mark/cups/nprint.2002011801
# AppleTalk/netatalk backend for CUPS
Source12: http://www.oeh.uni-linz.ac.at/~rupi/pap/pap-backend.tar.bz2
Source13: http://www.oeh.uni-linz.ac.at/~rupi/pap/pap-docu.pdf.bz2
Source14: http://www.linuxprinting.org/download/printing/photo_print
# Perl script for automatic configuration of CUPS, especially access
# restrictions and broadcasting
Source15: correctcupsconfig
Source16: cjktexttops
# Let printers have an ACL allowing rw for user lp, as our CUPS runs backends as lp:sys (mdv#49407, mga#10985)
# (blino) install after 73-seat-late.rules since the uaccess helper resets ACLs
Source17: 74-printers_lp_user_fix.rules
# Nice level for now. bug #16387
Source18: cups.sysconfig

### FEDORA PATCHES ###

Patch1: cups-no-gzip-man.patch
Patch2: cups-system-auth.patch
Patch3: cups-multilib.patch
Patch4: cups-dbus-utf8.patch
Patch5: cups-banners.patch
Patch6: cups-serverbin-compat.patch
Patch7: cups-no-export-ssllibs.patch
Patch8: cups-direct-usb.patch
Patch9: cups-lpr-help.patch
Patch10: cups-peercred.patch
Patch11: cups-pid.patch
Patch12: cups-eggcups.patch
Patch13: cups-driverd-timeout.patch
Patch14: cups-strict-ppd-line-length.patch
Patch15: cups-logrotate.patch
Patch16: cups-usb-paperout.patch
Patch17: cups-res_init.patch
Patch18: cups-filter-debug.patch
Patch19: cups-uri-compat.patch
Patch20: cups-str3382.patch
Patch21: cups-0755.patch
Patch22: cups-hp-deviceid-oid.patch
Patch23: cups-dnssd-deviceid.patch
Patch24: cups-ricoh-deviceid-oid.patch
Patch25: cups-systemd-socket.patch
Patch26: cups-lpd-manpage.patch
Patch27: cups-avahi-address.patch
Patch29: cups-enum-all.patch
Patch30: cups-stringpool-rdar15382819.patch
Patch31: cups-dymo-deviceid.patch
Patch32: cups-freebind.patch
Patch33: cups-no-gcry.patch
Patch34: cups-libusb-quirks.patch
Patch35: cups-use-ipp1.1.patch
Patch36: cups-avahi-no-threaded.patch
Patch37: cups-gz-crc.patch
Patch39: cups-ipp-multifile.patch
Patch40: cups-full-relro.patch
Patch41: cups-web-devices-timeout.patch
Patch43: cups-final-content-type.patch
Patch44: cups-jobhistory.patch
Patch45: cups-journal.patch
Patch46: cups-synconclose.patch
Patch47: cups-dbus-notifier.patch
# https://www.cups.org/str.php?L4319
Patch48: cups-1.7.0-CVE-2013-6891.diff
# https://www.cups.org/str.php?L4356
Patch49: cups-1.7.1-CVE-2014-2856.patch

Patch100: cups-lspp.patch

Requires: chkconfig
Requires: %{name}-filesystem = %{version}-%{release}

### MAGEIA PATCHES ###

##### ADDITIONAL DEFINITIONS #####

Url: http://www.cups.org
BuildRequires: acl-devel
BuildRequires: autoconf2.5
BuildRequires: glibc
BuildRequires: htmldoc
BuildRequires: krb-devel
BuildRequires: libdbus-devel >= 0.50
BuildRequires: libgnutls-devel
BuildRequires: libjpeg-devel, libpng-devel, libtiff-devel, libz-devel
BuildRequires: libopenslp-devel, libldap-devel
BuildRequires: libpam-devel
BuildRequires: libsystemd-daemon-devel
BuildRequires: libusb-devel
BuildRequires: openssl-devel
BuildRequires: systemd-units
BuildRequires: systemd-devel
%if !%bootstrap
BuildRequires: avahi-compat-libdns_sd-devel
BuildRequires: poppler
%endif
Requires: %{name}-common >= %{version}-%{release} 
Requires: openssl 
Requires: net-tools
Requires: printer-testpages
# Take care that device files are created with correct permissions
Requires: udev 
# For desktop menus
Requires: xdg-utils
Suggests: avahi
# Make sure we have some filters for converting to raster format.
Requires: cups-filters
# setfacl is used by 74-printers_lp_user_fix.rules
Requires: acl

# Requires /etc/tmpfiles.d (bug #656566)
Requires: systemd-units >= 13
Requires(post): systemd >= %{systemd_required_version}
Requires(post): systemd-units
Requires(preun): systemd-units
Requires(postun): systemd-units
Requires(post):  rpm-helper >= 0.24.8-1
Requires(preun): rpm-helper >= 0.24.8-1

%if !%bootstrap
Requires:	poppler
%endif

Provides:	cupsddk-drivers
Obsoletes:	cupsddk-drivers < 1.2.3-5
Obsoletes:	cupsddk < 1.4.0

%package common
Summary: Common Unix Printing System - Common stuff
License: GPLv2
Group: System/Printing
Requires: %{libname} >= %{version}-%{release} update-alternatives openssl net-tools
# To satisfy LSB/FHS
Provides: lpddaemon

%package -n %{libname}-devel
Summary: Common Unix Printing System - Development environment "libcups"
License: LGPLv2
Group: Development/C
Requires: libgnutls-devel
Requires: cups-common = %{version}-%{release}
Requires: %{libname} >= %{version}-%{release} openssl openssl-devel
Provides: libcups-devel = %{version}-%{release}
Provides: libcups2_1-devel = %{version}-%{release}
Obsoletes: cups-devel, libcups1-devel
Provides: cups-devel = %{version}, libcups1-devel = %{version}
Conflicts: cupsddk < 1.4.0

%package -n %{libname}
Summary: Common Unix Printing System - CUPS library
License: LGPLv2
Group: System/Libraries
Requires: openssl net-tools
Obsoletes: libcups1
Provides: libcups1 = %{version}

%package filesystem
Summary: CUPS printing system - directory layout
Group: 	 System/Printing
BuildArch: noarch
Conflicts: %{name} < %version-%release
 
%description
The Common Unix Printing System provides a portable printing layer for 
UNIX(TM) operating systems. It has been developed by Easy Software Products 
to promote a standard printing solution for all UNIX vendors and users. 
CUPS provides the System V and Berkeley command-line interfaces.
This is the main package needed for CUPS servers (machines where a
printer is connected to or which host a queue for a network
printer). It can also be used on CUPS clients so that they simply pick
up broadcasted printer information from other CUPS servers and do not
need to be assigned to a specific CUPS server by an
%{_sysconfdir}/cups/client.conf file.

%description common
CUPS 1.4 is fully compatible with CUPS-1.1 machines in the network and
with software built against CUPS-1.1 libraries.

The Common Unix Printing System provides a portable printing layer for
UNIX(TM) operating systems. It contains the command line utilities for
printing and administration (lpr, lpq, lprm, lpadmin, lpc, ...), man
pages, locales, and a sample configuration file for daemon-less CUPS
clients (%{_sysconfdir}/cups/client.conf).

This package you need for both CUPS clients and servers. 

%description -n %{libname}-devel
CUPS 1.4 is fully compatible with CUPS-1.1 machines in the network and
with software built against CUPS-1.1 libraries.

The Common Unix Printing System provides a portable printing layer for
UNIX(TM) operating systems. This is the development package for
creating additional printer drivers, printing software, and other CUPS
services using the main CUPS library "libcups".

%description -n %{libname}
CUPS 1.4 is fully compatible with CUPS-1.1 machines in the network and
with software built against CUPS-1.1 libraries.

The Common Unix Printing System provides a portable printing layer for
UNIX(TM) operating systems. This package contains the CUPS API library
which contains common functions used by both the CUPS daemon and all
CUPS frontends (lpr-cups, xpp, qtcups, kups, ...).

This package you need for both CUPS clients and servers. It is also
needed by Samba.

%description filesystem
CUPS printing system provides a portable printing layer for
UNIX® operating systems. This package provides some directories which are
required by other packages that add CUPS drivers (i.e. filters, backends etc.).

%prep
%setup -q -n %{name}-%{real_version}

# Don't gzip man pages in the Makefile, let rpmbuild do it.
%patch1 -p1 -b .no-gzip-man
# Use the system pam configuration.
%patch2 -p1 -b .system-auth
# Prevent multilib conflict in cups-config script.
%patch3 -p1 -b .multilib
# Ensure attributes are valid UTF-8 in dbus notifier (bug #863387).
%patch4 -p1 -b .dbus-utf8
# Ignore rpm save/new files in the banners directory.
%patch5 -p1 -b .banners
# Use compatibility fallback path for ServerBin.
%patch6 -p1 -b .serverbin-compat
# Don't export SSLLIBS to cups-config.
%patch7 -p1 -b .no-export-ssllibs
# Allow file-based usb device URIs.
%patch8 -p1 -b .direct-usb
# Add --help option to lpr.
%patch9 -p1 -b .lpr-help
# Fix compilation of peer credentials support.
%patch10 -p1 -b .peercred
# Maintain a cupsd.pid file.
%patch11 -p1 -b .pid
# Fix implementation of com.redhat.PrinterSpooler D-Bus object.
%patch12 -p1 -b .eggcups
# Increase driverd timeout to 70s to accommodate foomatic (bug #744715).
%patch13 -p1 -b .driverd-timeout
# Only enforce maximum PPD line length when in strict mode.
%patch14 -p1 -b .strict-ppd-line-length
# Re-open the log if it has been logrotated under us.
%patch15 -p1 -b .logrotate
# Support for errno==ENOSPACE-based USB paper-out reporting.
%patch16 -p1 -b .usb-paperout
# Re-initialise the resolver on failure in httpAddrGetList() (bug #567353).
%patch17 -p1 -b .res_init
# Log extra debugging information if no filters are available.
%patch18 -p1 -b .filter-debug
# Allow the usb backend to understand old-style URI formats.
%patch19 -p1 -b .uri-compat
# Fix temporary filename creation.
%patch20 -p1 -b .str3382
# Use mode 0755 for binaries and libraries where appropriate.
%patch21 -p1 -b .0755
# Add an SNMP query for HP's device ID OID (STR #3552).
%patch22 -p1 -b .hp-deviceid-oid
# Mark DNS-SD Device IDs that have been guessed at with "FZY:1;".
%patch23 -p1 -b .dnssd-deviceid
# Add an SNMP query for Ricoh's device ID OID (STR #3552).
%patch24 -p1 -b .ricoh-deviceid-oid
# Add support for systemd socket activation (patch from Lennart
# Poettering).
%patch25 -p1 -b .systemd-socket
# Talk about systemd in cups-lpd manpage (part of bug #884641).
%patch26 -p1 -b .lpd-manpage
# Use IP address when resolving DNSSD URIs (bug #948288).
%patch27 -p1 -b .avahi-address
# Return from cupsEnumDests() once all records have been returned.
%patch29 -p1 -b .enum-all
# Prevent stringpool damage leading to memory leaks (bug #974048).
%patch30 -p1 -b .stringpool-rdar15382819
# Added IEEE 1284 Device ID for a Dymo device (bug #747866).
%patch31 -p1 -b .dymo-deviceid
# Use IP_FREEBIND socket option when binding listening sockets (bug #970809).
%patch32 -p1 -b .freebind
# Don't link against libgcrypt needlessly.
%patch33 -p1 -b .no-gcry
# Added libusb quirk for Canon PIXMA MP540 (bug #967873).
%patch34 -p1 -b .libusb-quirks
# Default to IPP/1.1 for now (bug #977813).
%patch35 -p1 -b .use-ipp1.1
# Don't use D-Bus from two threads (bug #979748).
%patch36 -p1 -b .avahi-no-threaded
# Avoid sign-extending CRCs for gz decompression (bug #983486).
%patch37 -p1 -b .gz-crc
# Fixes for jobs with multiple files and multiple formats.
%patch39 -p1 -b .ipp-multifile
# Full relro (bug #996740).
%patch40 -p1 -b .full-relro
# Increase web interface get-devices timeout to 10s (bug #996664).
%patch41 -p1 -b .web-devices-timeout
# Reverted upstream change to FINAL_CONTENT_TYPE in order to fix
# printing to remote CUPS servers (bug #1010580).
%patch43 -p1 -b .final-content-type
# Fix job history logging.
%patch44 -p1 -b .jobhistory
# Allow "journal" log type for log output to system journal.
%patch45 -p1 -b .journal
# Set the default for SyncOnClose to Yes.
%patch46 -p1 -b .synconclose
# Avoid stale lockfile in dbus notifier (bug #1026949).
%patch47 -p1 -b .dbus-notifier
%patch48 -p1 -b .CVE-2013-6891
%patch49 -p1 -b .CVE-2013-2856

%if %lspp
# LSPP support.
%patch100 -p1 -b .lspp
%endif


# Let local printers be broadcasted in the local network(s)
perl -p -i -e 's:(Listen\s+)localhost:$1*:' conf/cupsd.conf.in
perl -p -i -e 's:(Browsing\s+On):$1\nBrowseAddress \@LOCAL:' conf/cupsd.conf.in
perl -p -i -e 's:(<Location\s+/\s*>):$1\n  Allow \@LOCAL:' conf/cupsd.conf.in

# Allow remote administration in local network (connections are encrypted,
# so no security problem)
perl -p -i -e 's:(<Location\s+/admin(|/conf)\s*>):$1\n  Allow \@LOCAL:' conf/cupsd.conf.in

# Let the Makefiles not trying to set file ownerships
perl -p -i -e "s/ -o \\$.CUPS_USER.//" scheduler/Makefile
perl -p -i -e "s/ -g \\$.CUPS_GROUP.//" scheduler/Makefile
perl -p -i -e "s/ -o \\$.CUPS_USER.//" systemv/Makefile
perl -p -i -e "s/ -g \\$.CUPS_GROUP.//" systemv/Makefile

# Work around bug on Mandriva compilation cluster (32-bit machine has
# /usr/lib64 directory)
perl -p -i -e 's:(libdir=")\$exec_prefix/lib64("):$1%{_libdir}$2:' config-scripts/cups-directories.m4

# Let's look at the compilation command lines.
perl -pi -e "s,^.SILENT:,," Makedefs.in

# Load additional tools
cp %{SOURCE1} poll_ppd_base.c
# Load nprint backend
cp %{SOURCE11} nprint
# Load AppleTalk "pap" backend
%setup -q -T -D -a 12 -n %{name}-%{version}%{cupsextraversion}
# Load the "pap" documentation
bzcat %{SOURCE13} > pap-docu.pdf
# Load the "photo_print" utility
cp %{SOURCE14} photo_print
# Load the "cjktexttops" filter
cp %{SOURCE16} cjktexttops



# For 'configure' the macro is not used, because otherwise one does not get the
# /etc and /var directories correctly hardcoded into the executables (they
# would get /usr/etc and /usr/var. In addition, the "--with-docdir" option
# has to be given because the default setting is broken.
aclocal -I config-scripts
autoconf -I config-scripts

%build
%serverbuild
# for the PHP module
%define _disable_ld_no_undefined 1
%setup_compile_flags
# cups uses $DSOFLAGS instead of $LDFLAGS for shared libs
export DSOFLAGS="$LDFLAGS"
#--enable-debug keeps debug symbols, doesn't affect anything else
%configure \
    --enable-debug \
    --enable-avahi \
    --disable-libpaper \
    --enable-raw-printing \
    --enable-ssl \
    --with-docdir=%{_datadir}/cups/doc \
    --with-icondir=%{_datadir}/icons \
    --with-system-groups="lpadmin root" \
    --with-xinetd=no \
%if !%bootstrap
    --with-pdftops=%{_bindir}/pdftops
%endif

%make

# Compile additional tools
%if %with_poll_ppd_base
gcc %optflags %ldflags -opoll_ppd_base -I. -I./cups poll_ppd_base.c -L./cups -lcups
%endif


%install
make install BUILDROOT=%{buildroot} \
             DOCDIR=%{buildroot}%{_datadir}/cups/doc \
             CHOWN=":" CHGRP=":" \
             LOGDIR=%{buildroot}%{_var}/log/cups \
             REQUESTS=%{buildroot}%{_var}/spool/cups \
             STATEDIR=%{buildroot}/run/cups

rm -rf	%{buildroot}%{_initddir} \
	%{buildroot}%{_sysconfdir}/init.d \
	%{buildroot}%{_sysconfdir}/rc?.d
mkdir -p %{buildroot}%{_unitdir}

# prepare the commands conflicting with LPD for the update-alternatives
# treatment
pushd $RPM_BUILD_ROOT%{_bindir}
for i in cancel lp lpq lpr lprm lpstat; do
       mv $i $i-cups
done
cd $RPM_BUILD_ROOT%{_sbindir}
for i in accept lpc lpmove reject; do
       mv $i $i-cups
done
cd $RPM_BUILD_ROOT%{_mandir}/man1
for i in cancel lp lpq lpr lprm lpstat; do
       mv $i.1 $i-cups.1
done
cd $RPM_BUILD_ROOT%{_mandir}/man8
for i in accept lpc lpmove; do
       mv $i.8 $i-cups.8
done
popd
ln -sf %{_sbindir}/accept-cups %{buildroot}%{_sbindir}/reject-cups
ln -sf %{_sbindir}/accept-cups %{buildroot}%{_sbindir}/cupsdisable
ln -sf %{_sbindir}/accept-cups %{buildroot}%{_sbindir}/cupsenable

# Install additional tools
%if %with_poll_ppd_base
install -m 755 poll_ppd_base %{buildroot}%{_bindir}
%endif

# Install nprint backend
install -m 755 nprint %{buildroot}%{cups_serverbin}/backend/

# Install AppleTalk backend
install -m 755 pap-backend/pap %{buildroot}%{cups_serverbin}/backend/
install -m 644 pap-docu.pdf %{buildroot}%{_datadir}/%{name}/doc

# Link dnssd backend as mdns backend
(cd %{buildroot}%{cups_serverbin}/backend && ln -s dnssd mdns)

# Install "photo_print"
install -m 755 photo_print %{buildroot}%{_bindir}

# Install "cjktexttops"
install -m 755 cjktexttops %{buildroot}%{cups_serverbin}/filter/

ln -s %{_datadir}/printer-testpages/testprint.ps %{buildroot}%{_datadir}/cups/data/testprint-mga.ps

# Install startup script
install -d %{buildroot}%{_sysconfdir}/sysconfig
install -m 644 %{SOURCE18} %{buildroot}%{_sysconfdir}/sysconfig/cups
install -d %{buildroot}%{_sysconfdir}/modprobe.d
rm -f %{buildroot}%{_sysconfdir}/init.d/cups

# Install script for automatic CUPS configuration
cp %{SOURCE15} %{buildroot}%{_sbindir}/correctcupsconfig
chmod a+rx %{buildroot}%{_sbindir}/correctcupsconfig

# Set compatibility links for the man pages and executables
ln -s %{_sbindir}/cupsenable %{buildroot}%{_bindir}/enable
ln -s %{_sbindir}/cupsenable %{buildroot}%{_bindir}/enable-cups
ln -s %{_sbindir}/cupsdisable %{buildroot}%{_bindir}/disable
ln -s %{_sbindir}/cupsdisable %{buildroot}%{_bindir}/disable-cups
ln -s %{_sbindir}/cupsenable %{buildroot}%{_sbindir}/enable-cups
ln -s %{_sbindir}/cupsdisable %{buildroot}%{_sbindir}/disable-cups
ln -s %{_mandir}/man8/cupsdisable.8 %{buildroot}%{_mandir}/man8/disable-cups.8
ln -s %{_mandir}/man8/cupsenable.8 %{buildroot}%{_mandir}/man8/enable-cups.8
ln -s %{_mandir}/man8/accept.8 %{buildroot}%{_mandir}/man8/reject-cups.8

%ifarch x86_64
# This one will be removed soon, when all other packages are
# modified appropriately
ln -s %{cups_serverbin} %{buildroot}%{_libdir}/cups
%endif

# Install missing headers (Thanks to Oden Eriksson)
install -m644 cups/debug-private.h  %{buildroot}%{_includedir}/cups/
install -m644 cups/string-private.h %{buildroot}%{_includedir}/cups/
install -m644 config.h %{buildroot}%{_includedir}/cups/

# Multiarch fixes
%multiarch_includes %{buildroot}%{_includedir}/cups/config.h

mkdir -p %{buildroot}%{_datadir}/pixmaps %{buildroot}%{_sysconfdir}/X11/sysconfig %{buildroot}%{_sysconfdir}/X11/applnk/System %{buildroot}%{_sysconfdir}/logrotate.d
install -p -m 644 %{SOURCE3} %{buildroot}%{_unitdir}
install -p -m 644 %{SOURCE4} %{buildroot}%{_unitdir}
install -p -m 644 %{SOURCE6} %{buildroot}%{_sysconfdir}/logrotate.d/cups
install -p -m 755 %{SOURCE7} %{buildroot}%{cups_serverbin}/backend/ncp

# Create dummy config files /etc/cups/printers.conf,
# /etc/cups/classes.conf, and /etc/cups/client.conf
touch %{buildroot}%{_sysconfdir}/cups/printers.conf
touch %{buildroot}%{_sysconfdir}/cups/classes.conf
touch %{buildroot}%{_sysconfdir}/cups/client.conf

# Remove links to the startup script, we make our own ones with chkconfig
rm -rf %{buildroot}%{_sysconfdir}/rc?.d/[SK]*
# Remove superflouus man page stuff
rm -rf %{buildroot}%{_mandir}/cat %{buildroot}%{_mandir}/*/cat
rm -rf %{buildroot}%{_mandir}/cat? %{buildroot}%{_mandir}/*/cat?
# there are pdf-banners shipped with cups-filters (#919489)
rm -rf $RPM_BUILD_ROOT%{_datadir}/cups/banners
rm -f $RPM_BUILD_ROOT%{_datadir}/cups/data/testprint

# install /usr/lib/tmpfiles.d/cups.conf (bug #656566)
mkdir -p %{buildroot}%{_tmpfilesdir}
cat > %{buildroot}%{_tmpfilesdir}/%{name}.conf <<EOF
# This file is part of cups.
#
# See tmpfiles.d(5) for details

d /run/cups 0755 root sys -
d /run/cups/certs 0511 lp lpadmin -
EOF

# /usr/lib/tmpfiles.d/cups-lp.conf (bug #812641)
cat > %{buildroot}%{_tmpfilesdir}/cups-lp.conf <<EOF
# Legacy parallel port character device nodes, to trigger the
# auto-loading of the kernel module on access.
#
# See tmpfiles.d(5) for details

c /dev/lp0 0660 root lp - 6:0
c /dev/lp1 0660 root lp - 6:1
c /dev/lp2 0660 root lp - 6:2
c /dev/lp3 0660 root lp - 6:3
EOF

# Prefer xdg-utils than htmlview (kde one)
sed -i s/htmlview/xdg-open/ %{buildroot}%{_datadir}/applications/*.desktop

# http://qa.mandriva.com/show_bug.cgi?id=28383
# Common PPD dirs
mkdir -p %{buildroot}%{_datadir}/ppd

# Make CUPS know them
ln -s /usr/local/share/ppd %{buildroot}%{_datadir}/cups/model/1-local-admin
ln -s /opt/share/ppd %{buildroot}%{_datadir}/cups/model/2-third-party
ln -s %{_datadir}/ppd %{buildroot}%{_datadir}/cups/model/3-distribution

# Common printer driver dirs
mkdir -p %{buildroot}%{_libdir}/printdriver
# Other dirs can't be handled here, but on %post instead.

# Install udev rules for letting backends access the printer devices.  Once
# CUPS runs backends as group 'lp', instead of 'sys, we may remove this.
mkdir -p %{buildroot}/lib/udev/rules.d
install -m 644 %{SOURCE17} %{buildroot}/lib/udev/rules.d/

%pre
%ifarch x86_64
# Fix /usr/lib/cups directory, so that updates can be done
if [ -d %{_libdir}/cups ] && ! [ -h %{_libdir}/cups ]; then
    if [ -h %{cups_serverbin} ] || ! [ -e %{cups_serverbin} ]; then
        rm -f %{cups_serverbin}
        mv %{_libdir}/cups %{cups_serverbin}
    else
        rm -rf %{_libdir}/cups.rpmsave
        mv %{_libdir}/cups %{_libdir}/cups.rpmsave
        #echo 'Moved %{_libdir}/cups to %{_libdir}/cups.rpmsave' 1>&2
    fi
fi
%endif
%_pre_groupadd lpadmin

%post
# (cg) Note: Not triggering the cups-lp.conf tmpfile here... should it be?
%_tmpfilescreate %{name}
# Make sure group ownerships are correct
chgrp -R sys %{_sysconfdir}/cups %{_var}/*/cups

# We can't enforce this. Bug #35993
for d in /opt/share/ppd /opt/lib/printdriver /usr/local/share/ppd /usr/local/lib/printdriver
do
  [ ! -e $d ] && mkdir -p $d || :
done
# End of 28383

# Apply our udev rules:
/sbin/udevadm trigger --sysname-match="lp[0-9]*" --sysname-match="parport[0-9]*" --sysname-match="irlpt[0-9]*"
/sbin/udevadm trigger --subsystem-match="usb" --attr-match=bInterfaceClass=07 --attr-match=bInterfaceSubClass=01
# wait for the permissions need to be ready
/sbin/udevadm settle --timeout=15

# Deal with config migration due to CVE-2012-5519 (STR #4223)
IN=%{_sysconfdir}/cups/cupsd.conf
OUT=%{_sysconfdir}/cups/cups-files.conf
copiedany=no
for keyword in AccessLog CacheDir ConfigFilePerm	\
    DataDir DocumentRoot ErrorLog FatalErrors		\
    FileDevice FontPath Group LogFilePerm		\
    LPDConfigFile PageLog Printcap PrintcapFormat	\
    RemoteRoot RequestRoot ServerBin ServerCertificate	\
    ServerKey ServerRoot SMBConfigFile StateDir		\
    SystemGroup SystemGroupAuthKey TempDir User; do
    if ! /bin/grep -iq ^$keyword "$IN"; then continue; fi
    copy=yes
    if /bin/grep -iq ^$keyword "$OUT"; then
	if [ "`/bin/grep -i ^$keyword "$IN"`" ==	\
	     "`/bin/grep -i ^$keyword "$OUT"`" ]; then
	    copy=no
	else
	    /bin/sed -i -e "s,^$keyword,#$keyword,i" "$OUT" || :
	fi
    fi
    if [ "$copy" == "yes" ]; then
	if [ "$copiedany" == "no" ]; then
	    (cat >> "$OUT" <<EOF

# Settings automatically moved from cupsd.conf by RPM package:
EOF
	    ) || :
	fi

	(/bin/grep -i ^$keyword "$IN" >> "$OUT") || :
	copiedany=yes
    fi

    /bin/sed -i -e "s,^$keyword,#$keyword,i" "$IN" || :
done

# Let CUPS daemon be automatically started at boot time
%_post_service cups
#_post_service cups-lpd

%preun
# Let CUPS daemon not be automatically started at boot time any more
%_preun_service cups
#_preun_service cups-lpd

%postun
%_postun_groupdel lpadmin
#_postun_service cups-lpd

%post common
# The lpc updates-alternative links were not correctly set in older CUPS
# packages, therefore remove the entry before making a new one when updating
%{_sbindir}/update-alternatives --remove lpc %{_sbindir}/lpc-cups || :
# Set up update-alternatives entries
%{_sbindir}/update-alternatives --install %{_bindir}/lpr lpr %{_bindir}/lpr-cups 10 --slave %{_mandir}/man1/lpr.1%{_extension} lpr.1%{_extension} %{_mandir}/man1/lpr-cups.1%{_extension}
%{_sbindir}/update-alternatives --install %{_bindir}/lpq lpq %{_bindir}/lpq-cups 10 --slave %{_mandir}/man1/lpq.1%{_extension} lpq.1%{_extension} %{_mandir}/man1/lpq-cups.1%{_extension}
%{_sbindir}/update-alternatives --install %{_bindir}/lprm lprm %{_bindir}/lprm-cups 10 --slave %{_mandir}/man1/lprm.1%{_extension} lprm.1%{_extension} %{_mandir}/man1/lprm-cups.1%{_extension}
%{_sbindir}/update-alternatives --install %{_bindir}/lp lp %{_bindir}/lp-cups 10 --slave %{_mandir}/man1/lp.1%{_extension} lp.1%{_extension} %{_mandir}/man1/lp-cups.1%{_extension}
%{_sbindir}/update-alternatives --install %{_bindir}/cancel cancel %{_bindir}/cancel-cups 10 --slave %{_mandir}/man1/cancel.1%{_extension} cancel.1%{_extension} %{_mandir}/man1/cancel-cups.1%{_extension}
%{_sbindir}/update-alternatives --install %{_bindir}/lpstat lpstat %{_bindir}/lpstat-cups 10 --slave %{_mandir}/man1/lpstat.1%{_extension} lpstat.1%{_extension} %{_mandir}/man1/lpstat-cups.1%{_extension}
%{_sbindir}/update-alternatives --install %{_sbindir}/accept accept %{_sbindir}/accept-cups 10 --slave %{_mandir}/man8/accept.8%{_extension} accept.8%{_extension} %{_mandir}/man8/accept-cups.8%{_extension}
%{_sbindir}/update-alternatives --install %{_sbindir}/disable disable %{_sbindir}/disable-cups 10 --slave %{_mandir}/man8/disable.8%{_extension} disable.8%{_extension} %{_mandir}/man8/disable-cups.8%{_extension}
%{_sbindir}/update-alternatives --install %{_sbindir}/enable enable %{_sbindir}/enable-cups 10 --slave %{_mandir}/man8/enable.8%{_extension} enable.8%{_extension} %{_mandir}/man8/enable-cups.8%{_extension}
%{_sbindir}/update-alternatives --install %{_sbindir}/lpc lpc %{_sbindir}/lpc-cups 10 --slave %{_mandir}/man8/lpc.8%{_extension} lpc.8%{_extension} %{_mandir}/man8/lpc-cups.8%{_extension}
%{_sbindir}/update-alternatives --install %{_sbindir}/lpmove lpmove %{_sbindir}/lpmove-cups 10 --slave %{_mandir}/man8/lpmove.8%{_extension} lpmove.8%{_extension} %{_mandir}/man8/lpmove-cups.8%{_extension}
%{_sbindir}/update-alternatives --install %{_sbindir}/reject reject %{_sbindir}/reject-cups 10 --slave %{_mandir}/man8/reject.8%{_extension} reject.8%{_extension} %{_mandir}/man8/reject-cups.8%{_extension}

%preun common
if [ "$1" = 0 ]; then
  # Remove update-alternatives entries
  %{_sbindir}/update-alternatives --remove lpr %{_bindir}/lpr-cups
  %{_sbindir}/update-alternatives --remove lpq %{_bindir}/lpq-cups
  %{_sbindir}/update-alternatives --remove lprm %{_bindir}/lprm-cups
  %{_sbindir}/update-alternatives --remove lp %{_bindir}/lp-cups
  %{_sbindir}/update-alternatives --remove cancel %{_bindir}/cancel-cups
  %{_sbindir}/update-alternatives --remove lpstat %{_bindir}/lpstat-cups
  %{_sbindir}/update-alternatives --remove accept %{_sbindir}/accept-cups
  %{_sbindir}/update-alternatives --remove disable %{_sbindir}/disable-cups
  %{_sbindir}/update-alternatives --remove enable %{_sbindir}/enable-cups
  %{_sbindir}/update-alternatives --remove lpc %{_sbindir}/lpc-cups
  %{_sbindir}/update-alternatives --remove lpmove %{_sbindir}/lpmove-cups
  %{_sbindir}/update-alternatives --remove reject %{_sbindir}/reject-cups
fi

%files
%doc *.txt
%config(noreplace) %attr(-,root,sys) %{_sysconfdir}/cups/cupsd.conf
%config(noreplace) %attr(0640,root,lp) %{_sysconfdir}/cups/cups-files.conf
%config(noreplace) %attr(-,root,root) %{_sysconfdir}/sysconfig/cups
%ghost %config(noreplace) %{_sysconfdir}/cups/printers.conf
%ghost %config(noreplace) %{_sysconfdir}/cups/classes.conf
%attr(-,root,sys) %{_sysconfdir}/cups/cupsd.conf.default
%config(noreplace) %attr(-,root,sys) %{_sysconfdir}/cups/interfaces
%config(noreplace) %attr(-,root,sys) %{_sysconfdir}/cups/ppd
%config(noreplace) %attr(-,root,sys) %{_sysconfdir}/cups/ssl
%config(noreplace) %attr(-,root,sys) %{_sysconfdir}/cups/snmp.conf
%config(noreplace) %attr(-,root,sys) %{_sysconfdir}/dbus*/system.d/cups.conf
%{_tmpfilesdir}/cups.conf
%{_tmpfilesdir}/cups-lp.conf
%dir %{_datadir}/%{name}/usb
%{_datadir}/%{name}/usb/org.cups.usb-quirks
%{_unitdir}/%{name}.service
%{_unitdir}/%{name}.socket
%{_unitdir}/%{name}.path
%config(noreplace) %{_sysconfdir}/pam.d/cups
%config(noreplace) %{_sysconfdir}/logrotate.d/cups
/lib/udev/rules.d/*.rules
%{cups_serverbin}/cgi-bin
%{cups_serverbin}/daemon
%{cups_serverbin}/notifier
%{cups_serverbin}/filter/*
%{cups_serverbin}/monitor
%{cups_serverbin}/backend/*
%{_datadir}/cups/ipptool
%{_datadir}/cups/drv/sample.drv
%{_datadir}/cups/examples
%{_datadir}/cups/mime/mime.types
%{_datadir}/cups/mime/mime.convs
%{_datadir}/cups/ppdc/*.defs
%{_datadir}/cups/ppdc/*.h
%{_datadir}/cups/templates
%{_datadir}/cups/data
%{_datadir}/cups/doc
%{_datadir}/cups/model
%{_datadir}/cups/profiles
%attr(0755,root,sys) %{_var}/log/cups
# Set ownerships of spool directory which is normally done by 'make install'
# Because RPM does 'make install' as normal user, this has to be done here
%dir %attr(0710,root,sys) %{_var}/spool/cups
%dir %attr(01770,root,sys) %{_var}/spool/cups/tmp
%dir %attr(775,root,sys) %{_var}/cache/cups
# Bug #28383 dirs
%dir %{_libdir}/printdriver
# Desktop icons
%{_datadir}/applications/*
%{_datadir}/icons/hicolor/*/apps/cups.png
%ifarch x86_64
# Compatibility link, will be removed soon
%{_libdir}/cups
%endif
%{_unitdir}/cups-lpd.socket
%{_unitdir}/cups-lpd@.service

%files common
%dir %config(noreplace) %attr(-,lp,sys) %{_sysconfdir}/cups
%ghost %config(noreplace) %attr(-,lp,sys) %{_sysconfdir}/cups/client.conf
%{_sbindir}/*
%{_bindir}/*cups
%{_bindir}/ipptool
%{_bindir}/ippfind
%{_bindir}/lpoptions
%attr(6755,root,sys) %{_bindir}/lppasswd
%{_bindir}/photo_print
%if %with_poll_ppd_base
%{_bindir}/poll_ppd_base
%endif
%{_bindir}/ppdc
%{_bindir}/ppdhtml
%{_bindir}/ppdi
%{_bindir}/ppdmerge
%{_bindir}/ppdpo
%{_bindir}/cupstestppd
%{_bindir}/cupstestdsc
%{_bindir}/enable
%{_bindir}/disable
%{_mandir}/man?/*
%lang(ca) %{_datadir}/locale/ca/cups_ca.po
%lang(cs) %{_datadir}/locale/cs/cups_cs.po
%lang(es) %{_datadir}/locale/es/cups_es.po
%lang(fr) %{_datadir}/locale/fr/cups_fr.po
%lang(ja) %{_datadir}/locale/ja/cups_ja.po
%lang(ru) %{_datadir}/locale/ru/cups_ru.po
%lang(it) %{_datadir}/locale/it/cups_it.po

%files -n %{libname}
%{_libdir}/*.so.*

%files filesystem
%dir %{cups_serverbin}
%dir %{cups_serverbin}/backend
%dir %{cups_serverbin}/driver
%dir %{cups_serverbin}/filter
%dir %{_datadir}/cups
%dir %{_datadir}/cups/data
%dir %{_datadir}/cups/drv
%dir %{_datadir}/cups/mime
%dir %{_datadir}/cups/model
%dir %{_datadir}/cups/ppdc
%dir %{_datadir}/ppd

%files -n %{libname}-devel
%{_includedir}/cups/*
%multiarch %{multiarch_includedir}/cups/*
%{_bindir}/cups-config
%{_libdir}/*.so



%changelog
* Tue Apr 22 2014 luigiwalser <luigiwalser> 1.7.0-7.1.mga4
+ Revision: 617402
- add patch from upstream via fedora to fix CVE-2014-2856

* Tue Jan 28 2014 colin <colin> 1.7.0-7.mga4
+ Revision: 568517
- Revert back to dnssd as CUPS support has been removed
- Address slow shutdown issues by updating avahi patch from Fedora rhbz#1044602

* Mon Jan 27 2014 colin <colin> 1.7.0-6.mga4
+ Revision: 568452
- Do not 'fix' configure as it will be rebuilt anyway.

  + neoclust <neoclust>
    - Use cups as default BrowseLocalProtocols

* Thu Jan 16 2014 oden <oden> 1.7.0-5.mga4
+ Revision: 566695
- P48: security fix for CVE-2013-6891

* Tue Nov 19 2013 tv <tv> 1.7.0-4.mga4
+ Revision: 551861
- avoid stale lockfile in dbus notifier (rhbz#1026949)
- use upstream patch for stringpool corruption issue (rhbz#974048)
- adjusted commented out default for SyncOnClose in cups-files.conf
- set the default for SyncOnClose to Yes

* Sun Nov 17 2013 blino <blino> 1.7.0-3.mga4
+ Revision: 551696
- install lp user fix udev rule after 73-seat-late.rules since the uaccess helper resets ACLs (#10985)
- run udev lp user fix on normal device, not parent (#10985), and merge with parport rule
- run udev lp user fix for bus/usb device too, not just usb/lp0 (#10985)
- add back udev rule to fix perms of USB devices for cups helpers like hplip (#10985)

* Wed Oct 30 2013 tv <tv> 1.7.0-2.mga4
+ Revision: 548016
- use upstream patch to fix job history

* Sun Oct 27 2013 colin <colin> 1.7.0-1.mga4
+ Revision: 547385
- Add Italian po file

  + fwang <fwang>
    - fix str fmt

  + tv <tv>
    - new release
    - fix job history logging
    - allow "journal" log type for log output to system journal

* Mon Oct 21 2013 umeabot <umeabot> 1.7-0.rc1.9.mga4
+ Revision: 538888
- Mageia 4 Mass Rebuild

* Thu Oct 03 2013 tv <tv> 1.7-0.rc1.8.mga4
+ Revision: 490874
- sync with FC:
  o revert upstream change to FINAL_CONTENT_TYPE in order to fix printing to
    remote CUPS servers (rhbz#1010580)
  o add SyncOnClose option (rhbz#984883)

* Wed Aug 21 2013 tv <tv> 1.7-0.rc1.7.mga4
+ Revision: 468988
- sync with FC:
  o increase web interface get-devices timeout to 10s (rhbz#996664)
  o build with full read-only relocations (rhbz#996740)
  o fixes for jobs with multiple files and multiple formats
  o fixed cups-config, broken by last change (rhbz#987660)
- do not force cups to run as lp:sys & drop udev rules (mga#10985)

* Mon Jul 29 2013 blino <blino> 1.7-0.rc1.6.mga4
+ Revision: 460402
- require acl since setfacl is used by 69-printers_lp_user_fix.rules (#10475)

* Fri Jul 26 2013 tv <tv> 1.7-0.rc1.5.mga4
+ Revision: 458363
- sync patches with RH (reverting unix2dos)

* Tue Jul 23 2013 joequant <joequant> 1.7-0.rc1.4.mga4
+ Revision: 457356
- revised cups-avahi-no-threaded patch which fixes segfault

* Sun Jul 21 2013 tv <tv> 1.7-0.rc1.3.mga4
+ Revision: 456677
- fix segfault (Joseph Wang)

* Wed Jul 17 2013 tv <tv> 1.7-0.rc1.2.mga4
+ Revision: 455225
- disable %%post action for cups-lpd: it's a socket, not a service

* Wed Jul 17 2013 tv <tv> 1.7-0.rc1.1.mga4
+ Revision: 455209
- RC1
- sync with FC
- remove pstops cost factor tweak (fixed in cups-filters 1.35)
- sync with FC:
  o use IP_FREEBIND socket option when binding listening sockets (rhz#970809)
  o don't link against libgcrypt needlessly
  o added usblp quirk for Canon PIXMA MP540 (rhz#967873)
  o default to IPP/1.1 for now (bug #977813)
  o fix for DNSSD name resolution

* Fri Jun 14 2013 tv <tv> 1.7-0.b1.3.mga4
+ Revision: 442974
- prevent stringpool damage leading to memory leaks (RH#974048)

* Thu Jun 13 2013 tv <tv> 1.7-0.b1.2.mga4
+ Revision: 442884
- relax requires

* Thu Jun 13 2013 tv <tv> 1.7-0.b1.1.mga4
+ Revision: 442832
- kill static libs
- add NCP backend
- kill more useless stuff
- migrate cups-lpd from xinetd to systemd socket activatable service
- use parallel make
- like FC, add a filesystem sub-package that own /usr/lib/cups/backend
  and the like, thus enabling packages that provide their own backends
  (such as samba-client and bluez-cups) to require only cups-filesystem
  and not the whole printing system

* Thu Jun 13 2013 tv <tv> 1.7-0.b1.mga4
+ Revision: 442516
- 1.7 beta1
- drop empty php-cups

* Tue Jun 04 2013 tv <tv> 1.6.2-4.mga4
+ Revision: 437133
- favor PDF printing over PS printing
  (http://www.linuxfoundation.org/collaborate/workgroups/openprinting/pdf_as_standard_print_job_format)

* Tue Jun 04 2013 tv <tv> 1.6.2-3.mga4
+ Revision: 437098
- requires cups-filters
- fix conflicts with cups-filters
- kill file require

* Sat Jun 01 2013 sander85 <sander85> 1.6.2-2.mga4
+ Revision: 434044
- Fix requires (usrmove)

* Thu May 30 2013 tv <tv> 1.6.2-1.mga4
+ Revision: 433418
- adjust file list
- adjust file list
- parallel backend is dead
- serial backend is dead
- adjust file list
- disable broken poll_ppd_base
- new release
- sync patches with FC
- drop merged patches

* Sun Mar 24 2013 colin <colin> 1.5.4-9.mga3
+ Revision: 404859
- Add systemd requires and general post/pre fixes (mga#9302)

* Tue Jan 15 2013 colin <colin> 1.5.4-8.mga3
+ Revision: 388297
- Fix up tmpfiles support (corrected groups to what the code uses)

  + umeabot <umeabot>
    - Mass Rebuild - https://wiki.mageia.org/en/Feature:Mageia3MassRebuild

* Sat Jan 05 2013 tmb <tmb> 1.5.4-7.mga3
+ Revision: 339330
- Dont enable IP-based systemd socket activation by default (mitigates CVE-2012-6094)

* Fri Dec 28 2012 cjw <cjw> 1.5.4-6.mga3
+ Revision: 335892
- patch104: usb backend exceptions for specific devices (from ubuntu/fedora)
- patch105: support for apple airprint (from ubuntu)

* Thu Dec 27 2012 cjw <cjw> 1.5.4-5.mga3
+ Revision: 335657
- drop exit 0 from post script that caused the cups service to be disabled after install (mga #8507)

* Thu Dec 20 2012 oden <oden> 1.5.4-4.mga3
+ Revision: 333330
- sync with mga2 updates

* Fri Dec 07 2012 oden <oden> 1.5.4-3.mga3
+ Revision: 327857
- P102: security fix for CVE-2012-5519 (upstream, redhat)
- merge spec file changes from fedora to deal with the new cups-files.conf file
- xinetd is not needed in buildrequires

* Thu Aug 02 2012 cjw <cjw> 1.5.4-2.mga3
+ Revision: 277717
- don't use portreserve, systemd will do this job

* Sat Jul 28 2012 cjw <cjw> 1.5.4-1.mga3
+ Revision: 275393
- new version 1.5.4
- do not blacklist the usblp driver, this should not be needed anymore according to upstream
- pass the full path to pdftops to configure so it does not find it in /bin due to /usr move

* Wed May 30 2012 guillomovitch <guillomovitch> 1.5.3-5.mga3
+ Revision: 250494
- ship tmpfiles to support legacy parallel printers
- drop sysinit support
- small spec cleanup
- new version
- sync fedora patches

* Sat Apr 28 2012 tmb <tmb> 1.5.2-5.mga2
+ Revision: 233653
- Require rpm-helper >= 0.24.8-1 for systemd support

* Fri Apr 27 2012 tmb <tmb> 1.5.2-4.mga2
+ Revision: 233546
- rebuild for versioned rpm-helper requires

* Mon Apr 02 2012 zezinho <zezinho> 1.5.2-3.mga2
+ Revision: 227831
- blacklist usblp as it prevents usb printer detection

* Mon Mar 26 2012 anssi <anssi> 1.5.2-2.mga2
+ Revision: 226537
- apply udev rules immediately in %%post, while changing the rules to be
  run on ACTION=="change" as well (part of bug #3616 fix (automatic printer
  installation))
- make cups %%pre more robust when cups is uninstalled and reinstalled
  multiple times

* Tue Feb 14 2012 colin <colin> 1.5.2-1.mga2
+ Revision: 208638
- New version: 1.5.2
- Add Hungarian translation
- Drop patches applied upstream
- Rediff (resync with Fedora) patches which do not apply

* Thu Dec 22 2011 fwang <fwang> 1.5.0-2.mga2
+ Revision: 186112
- rebuild for new libtiff

* Tue Dec 13 2011 dmorgan <dmorgan> 1.5.0-1.mga2
+ Revision: 181225
- New version 1.5.0
  Sync with Fedora
  Clean spec file

* Wed Oct 26 2011 doktor5000 <doktor5000> 1.4.8-3.mga2
+ Revision: 158294
- removed -fPIC from CFLAGS and CXXFLAGS
- properly add our {C,CXX,LD)FLAGS via %%setup_compile_flags
- exported our LDFLAGS as DSOFLAGS as cups uses those internally
- remove stripping handling, was not working before
- use %%optflags and %%ldflags for compiling the additional tools
- enable _disable_ld_no_undefined for the PHP module
- removed seperate debug handling
  o enabled back proper creation of -debug packages
  o moved debug symbols back from binary packages to -debug packages
- removed obsolete empty %%defattr and %%clean sections
- fixed CVE-2011-3170, heap-based buffer overflow allows remote attackers
  to possibly execute arbitrary code (str3914.patch, from upstream)

* Sat Sep 10 2011 fwang <fwang> 1.4.8-2.mga2
+ Revision: 142089
- rebuild for new libpng

* Thu Sep 08 2011 tv <tv> 1.4.8-1.mga2
+ Revision: 141579
- add missing LSB keywords
- rediff patch 35
- new release

* Mon Jun 20 2011 tv <tv> 1.4.6-4.mga2
+ Revision: 110405
- cups-devel requires gnutls-devel, otherwise cups-config fails

* Mon Mar 21 2011 dmorgan <dmorgan> 1.4.6-3.mga1
+ Revision: 75102
- Do not build in bootstrap mode anymore
- Remove old and buggy pdfdistiller ( tks to Luc Menut #483 )

* Sat Feb 19 2011 blino <blino> 1.4.6-2.mga1
+ Revision: 54313
- move printer device acl fix from system-config-printer-udev to cups
  (so that cups works standalone)

* Wed Jan 12 2011 dmorgan <dmorgan> 1.4.6-1.mga1
+ Revision: 7269
- Fix file list
- Do not make check now
- Rebuild with htmldoc
- Do not build htmldoc for now
- Do not build with avahi support for now
- Do not build php support for now
- Remove mdv macros
- Remove mdv macros
- imported package cups

  + ahmad <ahmad>
    - imported package cups

